const Main = imports.ui.main;
let _sourceId;

function onOverviewActivated() {
    Main.overview.dash.hide();
}

function onOverviewDeactivated() {
    _sourceId = GLib.timeout_add_seconds(GLib.PRIORITY_DEFAULT, delay, () => {
        Main.overview.dash.show();
        return GLib.SOURCE_CONTINUE;
    });
}

class DockExtension {
    enable() { 
        this.showingSignalId = Main.overview.connect('showing', onOverviewActivated);
        this.hiddenSignalId = Main.overview.connect('hiding', onOverviewDeactivated);
    }
    disable() {
        Main.overview.disconnect(this.showingSignalId);
        Main.overview.disconnect(this.hiddenSignalId);
        if (_sourceId) {
            GLib.Source.remove(_sourceId);
            _sourceId = null;
        }
    }
}

function init() {
    return new DockExtension(); 
}
